////////////////////////////////////////////////////////
//  pcidebug.dll
//                        Aug 20 1999 kashiwano masahiro
//
////////////////////////////////////////////////////////

#include <stdio.h>
#include <windows.h>
#include <winioctl.h>
#include <stddef.h>
#include <assert.h>

#include "pcidebug.h"
#include "driverload.h"

int GetFileInternalName(const char *file,char *name);

#include "resource.h"

int initialize(HMODULE ghInst);
int initialize_vxd(HMODULE ghInst);
void close(void);

extern void init_isr(void);

//#define DRIVERNAME_BASE "CrystalSysInfo"
//#define DRIVERNAME "\\\\.\\"DRIVERNAME_BASE

char DRIVERID[MAX_PATH];		//	"CrystalSysInfo"
char DRIVERFILENAME[MAX_PATH];//		"SysInfo.sys"
char DRIVERNAME[MAX_PATH];

#define DRIVERFILENAME95	"SysInfo.vxd"

HANDLE handle = NULL;
int drivertype = 0;

// DLL̏Ԃۑϐ
static DLLSTATUS status = DLLSTATUS_OTHERERROR;
//char DRIVERID[MAX_PATH];

//
// OS̎ނ𒲂ׂB
//
// ߂l	0: 擾łȂ
//			1: windows 3.1
//			2: windows 95
//			3: windows NT
//			-1:̑

int oscheck()
{
	OSVERSIONINFO os;
	os.dwOSVersionInfoSize = sizeof(os);
	if(GetVersionEx(&os) == 0){
		assert(0);
		return 0;
	}
	switch(os.dwPlatformId){
	case VER_PLATFORM_WIN32s:
		return 1;
	case VER_PLATFORM_WIN32_WINDOWS:
		return 2;
	case VER_PLATFORM_WIN32_NT:
		return 3;
	default:
		return -1;
	}
}

///////////////////////////////////////////////////////////
//
// DLLLOADꂽƂɃfoCXhCo[o^AJn
// DLLUNLOADꂽƂɃfoCXhCo[~O
//
///////////////////////////////////////////////////////////

BOOL APIENTRY DllMain(HMODULE hModule, 
                      DWORD  ul_reason_for_call, 
                      LPVOID lpReserved)
{
	char str[MAX_PATH];
	char name[64];

	int ostype;
	int res;
	int i;
	drivertype = 0;

	ostype = oscheck();

	GetModuleFileName(NULL,str,MAX_PATH);
	GetFileInternalName(str,name);

#ifdef _X86_64
	strcpy(DRIVERID,"CrystalSysInfo");
	strcpy(DRIVERFILENAME,"SysInfoX64.sys");
	strcpy(DRIVERNAME,"\\\\.\\CrystalSysInfo");
#else if
	strcpy(DRIVERID,"CrystalSysInfo");
	strcpy(DRIVERFILENAME,"SysInfo.sys");
	strcpy(DRIVERNAME,"\\\\.\\CrystalSysInfo");
#endif

	if( ostype == 2 ) { // 95 98̏ꍇ
		drivertype |= VXD_DRIVER_USE;
		drivertype |= PCIBIOS_READY;
		drivertype |= LIB_IO_FUNC_USE;
	} else if ( ostype == 3){ // NT̏ꍇ
		drivertype |= SYS_DRIVER_USE;		
	} else {
		// NT 95/98ȊȌꍇ
		status = DLLSTATUS_NOTSUPPORTEDPLATFORM;
	    return TRUE;
	}

    switch( ul_reason_for_call ) {
    case DLL_PROCESS_ATTACH:
		init_isr();
		if(drivertype & SYS_DRIVER_USE) {
			for(i=0;i<8;i++){
				res = initialize(hModule);
				if(res == 0){break;}
			}
		} else if(drivertype & VXD_DRIVER_USE) {
			res = initialize_vxd(hModule);
		} else {
			res = 3;
		}
		switch ( res ){
			case 0:
				status = DLLSTATUS_NOERROR;
				break;
			case 2:
				handle = NULL;
				status = DLLSTATUS_DRIVERNOTLOADED;
				break;
			default:
				handle = NULL;
				status = DLLSTATUS_OTHERERROR;
				break;
		}
		break;
	case DLL_THREAD_ATTACH:
		break;
    case DLL_THREAD_DETACH:
		break;
    case DLL_PROCESS_DETACH:
		close();
		status = DLLSTATUS_OTHERERROR;
		break;
    }
    return TRUE;
}


BOOL Opendriver(void)
{
	DWORD	dwStatus;

	handle = CreateFile(
		DRIVERNAME,
        GENERIC_READ | GENERIC_WRITE,
        FILE_SHARE_READ | FILE_SHARE_WRITE,
        NULL,
        OPEN_EXISTING,
        FILE_ATTRIBUTE_NORMAL,
        NULL
        );

	dwStatus = GetLastError();

    if (handle == INVALID_HANDLE_VALUE)
	{
		//hCo[I[vłȂꍇ
        return FALSE;
    }
	return TRUE;
}


DWORD GetRefCount(HANDLE hHandle)
{
	DWORD dwRefCount;
	ULONG ReturnedLength, IoctlResult;


	dwRefCount = (DWORD)-1;

	if(hHandle)
	{
		IoctlResult = DeviceIoControl(
                            hHandle,
                            IOCTL_GET_REFCONT,
                            NULL,
                            0,
                            &dwRefCount,
                            sizeof(dwRefCount),
                            &ReturnedLength,
                            NULL
                            );
	}
	if(!IoctlResult) dwRefCount = (DWORD)-1;

	return dwRefCount;
}

void close()
{
	DWORD dwRefCount;
	
	dwRefCount = GetRefCount(handle);

	if(handle) CloseHandle(handle);
	if(drivertype & SYS_DRIVER_USE)
	{
		if(dwRefCount==1)
			UnloadDriver(DRIVERID);
	}
	handle = NULL;
}


/*
	NThCo̓o^ƃhCo[Open

	
	ghInst	̃W[handle

	߂l
	0		I
	1		e|t@C쐬łȂ
	2		hCo[loadłȂ
	3		̑̃G[
*/
int initialize(HMODULE ghInst)
{

	BOOL	ret;
	char tmp[MAX_PATH];
	char path[MAX_PATH];
	char *ptrEnd;

	//hCo[I[vĂ݂
	if(Opendriver()) {
		status = DLLSTATUS_NOERROR;
		return 0;
	}
	//I[vłȂꍇ̓hCo[̓o^AJnB

    // hCo[̓o^AJn
	//GetCurrentDirectory(MAX_PATH, tmp);
	GetModuleFileName(NULL,tmp, MAX_PATH);
	if ( (ptrEnd = strrchr(tmp, '\\')) != NULL ) {*ptrEnd = '\0';}
	sprintf(path,"%s\\%s",tmp,DRIVERFILENAME);
	ret = LoadDriver(path, DRIVERID);
	if(ret == FALSE){
		/*
		GetWindowsDirectory(tmp, MAX_PATH);
		strcat( tmp, "\\system32\\drivers\\"DRIVERFILENAME);
		ret = LoadDriver(tmp, DRIVERID);
		if(ret == FALSE){
			return 2;
		}
		*/
		return 2;
	}
	// hCo[I[v
	if(Opendriver()) {
		status = DLLSTATUS_NOERROR;
		return 0;
	}
	// hCo[I[vłȂꍇ
	return 3;
}


/*
	95/98hCo̓o^ƃhCo[Open

	
	ghInst	̃W[handle

	߂l
	0		I
	1		e|t@C쐬łȂ
	3		̑̃G[
*/
int initialize_vxd(HMODULE ghInst)
{
    handle = CreateFile("\\\\.\\" DRIVERFILENAME95, 0, 0, NULL, 0, FILE_FLAG_DELETE_ON_CLOSE, NULL);
	if(handle == INVALID_HANDLE_VALUE) return 2;

	return 0; // 0k
}

/*
DLLSTATUS getdllstatus(void)
߂l
	DLLSTATUS_NOERROR				G[ȂB퓮쒆
	DLLSTATUS_DRIVERNOTLOADED		hCo[[hłȂ
	DLLSTATUS_NOTSUPPORTEDPLATFORM	T|[gĂȂ
	DLLSTATUS_OTHERERROR			̑G[
@\
	DLL̏ԂԂ
*/

DLLSTATUS WINAPI getdllstatus(void)
{
	return status;
}


int GetFileInternalName(const char *file,char *name)
{
	VS_FIXEDFILEINFO vffi;
	ULONG reserved = 0;	
	UINT size;
	char *buf = NULL, *vbuf;
	char str[256];
	int  Locale = 0;

	size = GetFileVersionInfoSize((char*)file,&reserved);
	str[0] = '\0';
	vbuf = (char*)malloc(size);

	if (GetFileVersionInfo((char*)file, 0, size, vbuf))
	{
		VerQueryValue(vbuf,TEXT("\\"),(void**)&buf,&size);
		CopyMemory( &vffi, buf, sizeof(VS_FIXEDFILEINFO));

		VerQueryValue(vbuf, "\\VarFileInfo\\Translation", (void**)&buf, &size);
		CopyMemory(&Locale, buf, sizeof(int));
		wsprintf(str,
					"\\StringFileInfo\\%04X%04X\\%s", 
					LOWORD(Locale), HIWORD(Locale),
					"InternalName"
				);
		VerQueryValue(vbuf,str,(void**)&buf,&size);

		strcpy(str,buf);
		if(name != NULL){
			strcpy(name,buf);
		}
	}
	if(vbuf) free(vbuf);

	return 0;
}



